Index: external/fastjet/LimitedWarning.cc
===================================================================
--- external/fastjet/LimitedWarning.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/LimitedWarning.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id$
+//FJSTARTHEADER
+// $Id: LimitedWarning.cc 3619 2014-08-13 14:17:19Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #include "fastjet/LimitedWarning.hh"
@@ -40,10 +42,10 @@
 
 
-/// output a warning to ostr
-void LimitedWarning::warn(const std::string & warning) {
-  warn(warning, _default_ostr);
-}
+// /// output a warning to ostr
+// void LimitedWarning::warn(const std::string & warning) {
+//   warn(warning, _default_ostr);
+// }
 
-void LimitedWarning::warn(const std::string & warning, std::ostream * ostr) {
+void LimitedWarning::warn(const char * warning, std::ostream * ostr) {
   if (_this_warning_summary == 0) {
     // prepare the information for the summary
@@ -54,5 +56,5 @@
     // prepare the warning within a string stream
     ostringstream warnstr;
-    warnstr << "WARNING: ";
+    warnstr << "WARNING from FastJet: ";
     warnstr << warning;
     _n_warn_so_far++;
Index: external/fastjet/LimitedWarning.hh
===================================================================
--- external/fastjet/LimitedWarning.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/LimitedWarning.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -2,8 +2,8 @@
 #define __FASTJET_LIMITEDWARNING_HH__
 
-//STARTHEADER
-// $Id: LimitedWarning.hh 2577 2011-09-13 15:11:38Z salam $
+//FJSTARTHEADER
+// $Id: LimitedWarning.hh 3622 2014-08-13 14:45:45Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -16,7 +16,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -28,5 +30,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
@@ -50,12 +52,19 @@
 
   /// constructor that provides a user-set max number of warnings
-  LimitedWarning(int max_warn) : _max_warn(max_warn), _n_warn_so_far(0), _this_warning_summary(0) {}
+  LimitedWarning(int max_warn_in) : _max_warn(max_warn_in), _n_warn_so_far(0), _this_warning_summary(0) {}
 
   /// outputs a warning to standard error (or the user's default
   /// warning stream if set)
-  void warn(const std::string & warning);
+  void warn(const char * warning) {warn(warning, _default_ostr);}
+
+  /// outputs a warning to standard error (or the user's default
+  /// warning stream if set)
+  void warn(const std::string & warning) {warn(warning.c_str(), _default_ostr);}
 
   /// outputs a warning to the specified stream
-  void warn(const std::string & warning, std::ostream * ostr);
+  void warn(const char * warning, std::ostream * ostr);
+
+  /// outputs a warning to the specified stream
+  void warn(const std::string & warning, std::ostream * ostr) {warn(warning.c_str(), ostr);}
 
   /// sets the default output stream for all warnings (by default
@@ -70,4 +79,12 @@
     _max_warn_default = max_warn;
   }
+
+  /// the maximum number of warning messages that will be printed
+  /// by this instance of the class
+  int max_warn() const {return _max_warn;}
+
+  /// the number of times so far that a warning has been registered
+  /// with this instance of the class.
+  int n_warn_so_far() const {return _n_warn_so_far;}
 
   /// returns a summary of all the warnings that came through the
Index: external/fastjet/MinHeap.cc
===================================================================
--- external/fastjet/MinHeap.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/MinHeap.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id$
+//FJSTARTHEADER
+// $Id: MinHeap.cc 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #include "fastjet/internal/MinHeap.hh"
@@ -43,5 +45,5 @@
 ///
 ///   . for _heap[i], the "parent" is to be found at (i-1)/2
-void MinHeap::_initialise(const std::vector<double> & values){
+void MinHeap::initialise(const std::vector<double> & values){
   
   // fill the high-range of the heap with the largest possible value
Index: external/fastjet/NNH.hh
===================================================================
--- external/fastjet/NNH.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/NNH.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -2,8 +2,8 @@
 #define __FASTJET_NNH_HH__
 
-//STARTHEADER
-// $Id: NNH.hh 3203 2013-09-15 07:49:50Z salam $
-//
-// Copyright (c) 2009, Matteo Cacciari, Gavin Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: NNH.hh 3433 2014-07-23 08:17:03Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -16,7 +16,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -28,5 +30,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #include<fastjet/ClusterSequence.hh>
@@ -138,5 +140,5 @@
   class NNBJ; // forward declaration
   
-  /// establish the nearest neighbour for jet, and cross check constistency
+  /// establish the nearest neighbour for jet, and cross check consistency
   /// of distances for the other jets that are encountered. Assumes
   /// jet not contained within begin...end
Index: external/fastjet/PseudoJet.cc
===================================================================
--- external/fastjet/PseudoJet.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/PseudoJet.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id$
-//
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: PseudoJet.cc 3565 2014-08-11 15:24:39Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
@@ -176,4 +178,8 @@
 // return the product, coeff * jet
 PseudoJet operator* (double coeff, const PseudoJet & jet) {
+  // see the comment in operator*= about ensuring valid rap phi
+  // before a multiplication to handle case of multiplication by
+  // zero, while maintaining rapidity and phi
+  jet._ensure_valid_rap_phi(); 
   //return PseudoJet(coeff*jet.four_mom());
   // the following code is hopefully more efficient
@@ -198,4 +204,12 @@
 /// multiply the jet's momentum by the coefficient
 void PseudoJet::operator*=(double coeff) {
+  // operator*= aims to maintain the rapidity and azimuth
+  // for the PseudoJet; if they have already been evaluated
+  // this is fine, but if they haven't and coeff is sufficiently
+  // small as to cause a zero or underflow result, then a subsequent
+  // invocation of rap or phi will lead to a non-sensical result. 
+  // So, here, we preemptively ensure that rapidity and phi
+  // are correctly cached
+  _ensure_valid_rap_phi(); 
   _px *= coeff;
   _py *= coeff;
@@ -261,6 +275,6 @@
 
 //----------------------------------------------------------------------
-/// transform this jet (given in lab) into a jet in the rest
-/// frame of prest
+/// transform this jet (given in the rest frame of prest) into a jet
+/// in the lab frame 
 //
 // NB: code adapted from that in herwig f77 (checked how it worked
@@ -288,6 +302,6 @@
 
 //----------------------------------------------------------------------
-/// transform this jet (given in the rest frame of prest) into a jet
-/// in the lab frame;
+/// transform this jet (given in lab) into a jet in the rest
+/// frame of prest  
 //
 // NB: code adapted from that in herwig f77 (checked how it worked
@@ -587,5 +601,5 @@
 // an Error is thrown if this PseudoJet has no currently valid
 // associated ClusterSequence
-std::vector<PseudoJet> PseudoJet::exclusive_subjets (const double & dcut) const {
+std::vector<PseudoJet> PseudoJet::exclusive_subjets (const double dcut) const {
   return validated_structure_ptr()->exclusive_subjets(*this, dcut);
 }
@@ -598,5 +612,5 @@
 // an Error is thrown if this PseudoJet has no currently valid
 // associated ClusterSequence
-int PseudoJet::n_exclusive_subjets(const double & dcut) const {
+int PseudoJet::n_exclusive_subjets(const double dcut) const {
   return validated_structure_ptr()->n_exclusive_subjets(*this, dcut);
 }
Index: external/fastjet/PseudoJet.hh
===================================================================
--- external/fastjet/PseudoJet.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/PseudoJet.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id: PseudoJet.hh 3111 2013-05-04 08:17:27Z salam $
+//FJSTARTHEADER
+// $Id: PseudoJet.hh 3566 2014-08-11 15:36:34Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
@@ -571,5 +573,5 @@
   /// structure type
   ///
-  /// If there is no sructure associated, an Error is thrown.
+  /// If there is no structure associated, an Error is thrown.
   /// If the type is not met, a std::bad_cast error is thrown.
   template<typename StructureType>
@@ -664,5 +666,5 @@
   /// an Error is thrown if this PseudoJet has no currently valid
   /// associated ClusterSequence
-  std::vector<PseudoJet> exclusive_subjets (const double & dcut) const;
+  std::vector<PseudoJet> exclusive_subjets (const double dcut) const;
 
   /// return the size of exclusive_subjets(...); still n ln n with same
@@ -672,5 +674,5 @@
   /// an Error is thrown if this PseudoJet has no currently valid
   /// associated ClusterSequence
-  int n_exclusive_subjets(const double & dcut) const;
+  int n_exclusive_subjets(const double dcut) const;
 
   /// return the list of subjets obtained by unclustering the supplied
@@ -694,6 +696,8 @@
   std::vector<PseudoJet> exclusive_subjets_up_to (int nsub) const;
 
-  /// return the dij that was present in the merging nsub+1 -> nsub 
+  /// Returns the dij that was present in the merging nsub+1 -> nsub 
   /// subjets inside this jet.
+  ///
+  /// Returns 0 if there were nsub or fewer constituents in the jet.
   ///
   /// an Error is thrown if this PseudoJet has no currently valid
@@ -701,7 +705,9 @@
   double exclusive_subdmerge(int nsub) const;
 
-  /// return the maximum dij that occurred in the whole event at the
+  /// Returns the maximum dij that occurred in the whole event at the
   /// stage that the nsub+1 -> nsub merge of subjets occurred inside 
   /// this jet.
+  ///
+  /// Returns 0 if there were nsub or fewer constituents in the jet.
   ///
   /// an Error is thrown if this PseudoJet has no currently valid
@@ -802,4 +808,7 @@
   /// set cached rapidity and phi values
   void _set_rap_phi() const;
+
+  // needed for operator* to have access to _ensure_valid_rap_phi()
+  friend PseudoJet operator*(double, const PseudoJet &);
 };
 
@@ -825,8 +834,10 @@
 /// momentum components are equal to val (=0.0)
 bool operator==(const PseudoJet & jet, const double val);
+inline bool operator==(const double val, const PseudoJet & jet) {return jet == val;}
 
 /// Can only be used with val=0 and tests whether at least one of the
 /// four momentum components is different from val (=0.0)
-inline bool operator!=(const PseudoJet & a, const double & val) {return !(a==val);}
+inline bool operator!=(const PseudoJet & a, const double val)  {return !(a==val);}
+inline bool operator!=( const double val, const PseudoJet & a) {return !(a==val);}
 
 inline double dot_product(const PseudoJet & a, const PseudoJet & b) {
@@ -881,5 +892,5 @@
     _ref_values = reference_values;
   };
-  inline int operator() (const int & i1, const int & i2) const {
+  inline int operator() (const int i1, const int i2) const {
     return  (*_ref_values)[i1] < (*_ref_values)[i2];
   };
Index: external/fastjet/PseudoJetStructureBase.cc
===================================================================
--- external/fastjet/PseudoJetStructureBase.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/PseudoJetStructureBase.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id$
-//
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: PseudoJetStructureBase.cc 3433 2014-07-23 08:17:03Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
Index: external/fastjet/PseudoJetStructureBase.hh
===================================================================
--- external/fastjet/PseudoJetStructureBase.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/PseudoJetStructureBase.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -2,8 +2,8 @@
 #define __FASTJET_PSEUDOJET_STRUCTURE_BASE_HH__
 
-//STARTHEADER
-// $Id: PseudoJetStructureBase.hh 3071 2013-04-01 12:52:46Z cacciari $
-//
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: PseudoJetStructureBase.hh 3433 2014-07-23 08:17:03Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -16,7 +16,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -28,5 +30,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
@@ -156,4 +158,9 @@
   ///
   /// By default, throws an Error
+  ///
+  /// Note: in a future major release of FastJet (4 or higher), 
+  /// "const double & dcut" may be replaced with "const double dcut",
+  /// requiring a modification of derived classes that overload
+  /// this function.
   virtual std::vector<PseudoJet> exclusive_subjets(const PseudoJet &reference, const double & dcut) const;
 
@@ -163,4 +170,9 @@
   ///
   /// By default, throws an Error
+  ///
+  /// Note: in a future major release of FastJet (4 or higher), 
+  /// "const double & dcut" may be replaced with "const double dcut",
+  /// requiring a modification of derived classes that overload
+  /// this function.
   virtual int n_exclusive_subjets(const PseudoJet &reference, const double & dcut) const;
 
Index: external/fastjet/RangeDefinition.cc
===================================================================
--- external/fastjet/RangeDefinition.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/RangeDefinition.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id$
+//FJSTARTHEADER
+// $Id: RangeDefinition.cc 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #include "fastjet/RangeDefinition.hh"
Index: external/fastjet/RangeDefinition.hh
===================================================================
--- external/fastjet/RangeDefinition.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/RangeDefinition.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id: RangeDefinition.hh 2577 2011-09-13 15:11:38Z salam $
+//FJSTARTHEADER
+// $Id: RangeDefinition.hh 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #ifndef __FASTJET_RANGEDEFINITION_HH__
Index: external/fastjet/RectangularGrid.cc
===================================================================
--- external/fastjet/RectangularGrid.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/RectangularGrid.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -0,0 +1,135 @@
+//FJSTARTHEADER
+// $Id$
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+
+
+#include "fastjet/RectangularGrid.hh"
+#include <sstream>
+using namespace std;
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+  /// dummy ctor (will give an unusable grid)
+RectangularGrid::RectangularGrid()
+    : _ymax(-1.0), _ymin(1.0), _requested_drap(-1.0), _requested_dphi(-1.0) {
+  // put in nonsensical values for the other variables too, to keep coverity happy
+  _ntotal = -1;
+  _ngood  = -1;
+  _dy = 0.0;
+  _dphi = 0.0;
+  _cell_area = 0.0;
+  _inverse_dy = 0;
+  _inverse_dphi = 0;
+  _ny   = 0;
+  _nphi = 0;
+}
+
+
+int RectangularGrid::tile_index(const PseudoJet & p) const {
+  // the code below has seem some degree of optimization: don't change
+  // it without testing the speed again
+
+  // new version as of 2014-08-04
+  double y_minus_ymin = p.rap() - _ymin;
+  if (y_minus_ymin < 0) return -1;
+  int iy = int(y_minus_ymin * _inverse_dy); // guaranteed positive, so int is safe
+  if (iy >= _ny) return -1;
+
+  // old version: gives a SoftKiller that's about 10% slower on Gavin's retina mac.
+  // (though having it hard coded inside SoftKiller returns that advantage)
+  // BUT: some comments said that this was a factor of two faster than
+  //      something similar to the version above. What is going on?
+  // int iy = int(floor( (p.rap() - _ymin) * _inverse_dy ));
+  // if (iy < 0 || iy >= _ny) return -1;
+
+  int iphi = int( p.phi() * _inverse_dphi );
+  if (iphi == _nphi) iphi = 0; // just in case of rounding errors
+
+  return iy*_nphi + iphi;
+}
+
+
+//----------------------------------------------------------------------
+void RectangularGrid::_setup_grid() {
+  // initial sanity checks
+  assert(_ymax > _ymin);
+  assert(_requested_drap > 0);
+  assert(_requested_dphi > 0);
+
+  double ny_double = (_ymax-_ymin) / _requested_drap;
+  _ny = max(int(ny_double+0.5),1);
+  _dy = (_ymax-_ymin) / _ny;
+  _inverse_dy = _ny/(_ymax-_ymin);
+  
+  _nphi = int (twopi / _requested_dphi + 0.5);
+  _dphi = twopi / _nphi;
+  _inverse_dphi = _nphi/twopi;
+
+  // some sanity checking (could throw a fastjet::Error)
+  assert(_ny >= 1 && _nphi >= 1);
+
+  _ntotal = _nphi * _ny;
+  //_max_pt.resize(_ntotal);
+  _cell_area = _dy * _dphi;
+
+  // if we have a selector, establish which tiles are good;
+  // apply the selector to a 4-vector at the tile's centre
+  if (_tile_selector.worker()) {
+    _is_good.resize(n_tiles());
+    _ngood = 0;
+    for (int i = 0; i < n_tiles(); i++) {
+      int iphi = i % _nphi;
+      int irap = i / _nphi;
+      double phi = (iphi + 0.5)*_dphi;
+      double rap = (irap + 0.5)*_dy + _ymin;
+      _is_good[i] = _tile_selector.pass(PtYPhiM(1.0, rap, phi));
+      if (_is_good[i]) _ngood++;
+    }
+  } else {
+    _ngood = n_tiles();
+  }
+}
+
+//----------------------------------------------------------------------
+string RectangularGrid::description() const {
+  if (! is_initialised())
+    return "Uninitialised rectangular grid";
+
+  ostringstream oss;
+  oss << "rectangular grid with rapidity extent " << _ymin << " < rap < " << _ymax
+      << ", tile size drap x dphi = " << _dy << " x " << _dphi;
+
+  if (_tile_selector.worker()) {
+    oss << ", good tiles are those that pass selector " <<  _tile_selector.description();
+  }
+  return oss.str();
+}
+
+FASTJET_END_NAMESPACE      // defined in fastjet/internal/base.hh
